## openmodelica 1.12.0~9-g6f68ff6

=== debian/changelog ===
openmodelica (1.12.0~9-g6f68ff6-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Fri, 19 Mar 2021 10:09:37 -0000

=== debian/control ===
Source: openmodelica
Section: math
Priority: optional
Maintainer: OpenModelica Build System <build@openmodelica.org>
Build-Depends: debhelper (>= 9.0.0),
# sbuild i386 does not handle native, cross-compile armhf requires it...
 clang:native | clang,
 gfortran:native | gfortran,
 default-jdk:native | default-jdk,
 omniidl:native (>= 4.0.0) | omniidl4:native | omniidl (>= 4.0.0) | omniidl4,
 libhwloc-dev:native | libhwloc-dev,
 automake,
 libtool,
 uuid-dev,
 libncurses5-dev,
 libsqlite3-dev,
 cmake (>= 2.8.6),
# libssl-dev (>= 0.9.8g), # Do we really depend on libssl directly? Debian stretch conflicts with it...
 libreadline-dev,
 qtbase5-dev,
 libqt5svg5-dev,
 qttools5-dev-tools,
 libqt5opengl5-dev,
 libqt5webkit5-dev,
 libqt5xmlpatterns5-dev,
 liblpsolve55-dev (>= 5.5.0.10),
 libomniorb4-dev,
 libhdf5-serial-dev | libhdf5-dev,
 liblapack-dev,
 autoconf,
 libexpat1-dev,
 libiomp-dev,
# Should be needed but seems to mess up sbuild
# libexpat1-dev:native,
 libboost-all-dev,
 libopenscenegraph-dev,
 pkg-config,
 lsb-release
Standards-Version: 3.9.5

Package: openmodelica
Section: math
Architecture: any
Depends: omc (<< 20000),
 omplot (<< 20000),
 omlib-modelica-3.2.2 | omlib-modelica-3.2.1,
 omshell (<< 20000),
 omshell-terminal (<< 20000),
 omnotebook (<< 20000),
 drmodelica (<< 20000),
 drcontrol (<< 20000),
 omedit (<< 20000),
# omoptim,
 ${misc:Depends}
Description: A complete Modelica environment
 The goal of the project is to create a complete Modelica modeling, compilation
 and simulation environment based on free software distributed in binary and
 source code form.
 .
 This package is a Debian metapackage. After installation this package can be
 removed. This metapackage pulls in the following OpenModelica packages:
 .
 1. Package omc the OpenModelica Compiler/Interpreter (omc)
 2. Package omshell the OpenModelica Shell (OMShell)
 3. Package omshell-terminal the OpenModelica Shell-terminal (OMShell-terminal)
 4. Package omlib-modelica-3.2.x the Modelica Standard Library version 3.2.x
 5. Package omnotebook the OpenModelica Notebook, with DrModelica and DrControl
 6. Package omedit, a Modelica connection editor for OpenModelica
 7. Package omoptim, a tool for optimization of Modelica models (temporarily removed while the build system is being updated)
 8. Package omplot, the plot tools for OpenModelica

Package: omc
Section: math
Architecture: any
Depends: clang,
 build-essential,
 libexpat1-dev,
 liblapack-dev,
 zip,
 unzip,
 omc-common,
 libomc,
 libomcsimulation,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: omplot,
 gnuplot-nox,
 xsltproc,
 libsaxonb-java
Suggests: python-beautifulsoup
Description: The OpenModelica Compiler
 This is the core of the OpenModelica project. It can be used stand-alone as
 a compiler. It is recommended to use it together with an OpenModelica client,
 such as OMShell (textual interface), OMNotebook (for teaching purposes)
 or OMEdit (graphical modeling).

Package: libomc
Section: math
Multi-Arch: same
Architecture: any
Depends: omc-common (<< 20000),
 libomcsimulation (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler lib dependencies
 This is the core libraries of the OpenModelica project.

Package: libomc-dev
Section: math
Multi-Arch: same
Architecture: any
Depends: libomc (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler lib dependencies
 This is the core libraries of the OpenModelica project.
 Currently contains antlr3 include-files.

Package: libomcsimulation
Section: math
Multi-Arch: same
Architecture: any
Depends: omc-common (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler simulation library dependencies
 This is the core libraries of the OpenModelica project and can be
 used for cross-compiling simulation executables and FMU's.

Package: omc-common
Section: math
Multi-Arch: foreign
Architecture: all
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler lib dependencies
 This is the core libraries of the OpenModelica project.

Package: omc-java
Section: math
Multi-Arch: foreign
Architecture: all
Depends: omc (<< 20000), ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Java interface
 Contains jar-files to interface with OpenModelica

Package: omplot
Section: math
Architecture: any
Depends: libomplot (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plot tool for OpenModelica
 This tool is essential for using the plot() command in omc.

Package: libomplot
Section: math
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Plot tool for OpenModelica, lib dependencies
 This tool is essential for using the plot() command in omc.

Package: libomplot-dev
Section: math
Multi-Arch: same
Architecture: any
Depends: libomplot (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plot tool for OpenModelica, development package
 This tool is essential for using the plot() command in omc.

Package: omedit
Section: math
Architecture: any
Depends: omc (<< 20000),
 omlib-modelica-3.2.2 | omlib-modelica-3.2.1,
 omlib-modelicareference,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica connection editor for OpenModelica
 OMEdit is still in active development. Please try it out and give feedback.

Package: omnotebook
Section: math
Architecture: any
Depends: omc (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: drmodelica,
 drcontrol,
 texlive-latex-base,
 dvipng
Description: A Mathematica-style Notebook for OpenModelica

Package: drmodelica
Section: math
Multi-Arch: foreign
Architecture: all
Depends: omnotebook (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in the Modelica language
 The course is based on Peter Fritzson's book
 “Principles of Object-Oriented Modeling and Simulation with Modelica 2.1”.

Package: drcontrol
Section: math
Multi-Arch: foreign
Architecture: all
Depends: omnotebook (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in basic control theory

Package: omshell-terminal
Section: math
Architecture: any
Depends: omc (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on readline)

Package: omshell
Section: math
Architecture: any
Depends: omc (<< 20000),
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on Qt)

Package: libomccpp
Section: math
Architecture: i386 amd64
Multi-Arch: same
Depends: libboost-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-serialization-dev,
 libboost-program-options-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Libraries for the C++ code generation target of OpenModelica

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# OpenModelica debian/rules that uses debhelper.
# Based on a sample file with GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ARCH ?= $(shell uname -m | sed s/i[0-9]86/x86/)

# Some variables to install binaries under debian/tmp
DEST   = $(CURDIR)/debian/tmp
SRCD   = $(CURDIR)

CLANGVER ?= $(shell clang --version | grep -o "clang version [0-9.]*" | cut "-d " -f3)

# Try to compile with gcc rather than old gcc versions
ifeq (3.0,$(CLANGVER))

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CC = gcc
	CXX = g++
else
  CC = $(DEB_HOST_GNU_TYPE)-gcc
  CXX = $(DEB_HOST_GNU_TYPE)-g++
endif

else

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CC = clang
	CXX = clang++
	CONF_OPTS_CROSS = --without-omc
else
	CC = clang -target $(DEB_HOST_GNU_TYPE)
# clang++ seems unable to find some bits stuff in C++ includes
  CXX = $(DEB_HOST_GNU_TYPE)-g++
# Even GCC needs special flags because libreadline seems messed up
# Readline needed this, but messes up other libraries: -Wl,--unresolved-symbols=ignore-all
  LDFLAGS = -Wl,-rpath-link -Wl,/lib/$(DEB_HOST_GNU_TYPE) -Wl,-rpath-link -Wl,/usr/lib/$(DEB_HOST_GNU_TYPE)
	NATIVE_CC = clang
	NATIVE_CXX = clang++
	CONF_OPTS_CROSS = --with-omc="`pwd`/cross-build/bin/omc"
endif

endif

ifeq (arm-linux-gnueabihf,$(DEB_HOST_GNU_TYPE))
	CONF_OPTS=--without-cppruntime
	CFLAGS += -march=armv6 -marm
	LDFLAGS += -march=armv6 -marm
	EXTRA_INSTALL=
else
	CONF_OPTS=--with-cppruntime
	EXTRA_INSTALL=
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#endif

# march=pentium4 used to be enabled because omc required sse2 regardless
# ifeq (x86,$(ARCH))
#        CFLAGS += -march=pentium4
# endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure.ac
	autoconf

build: build-stamp
build-arch: build
build-indep: build

build-stamp: configure
	dh_testdir
	# We might be cross-compiling. If so, we need a working omc. Easiest way? Build it ourselves.
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	./configure CFLAGS="$(CFLAGS)" CC=$(NATIVE_CC) CXX=$(NATIVE_CXX) OMPCC="gcc -fopenmp" \
	--host=$(DEB_BUILD_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--without-METIS \
	--without-FMIL \
	--without-lapack \
	--without-omniORB \
	--without-paradiseo \
	--disable-omshell-terminal \
	--without-lpsolve \
	--without-ipopt \
	--with-cppruntime \
	--without-omlibrary \
	--disable-modelica3d \
	$(CONF_OPTS)
	$(MAKE) $(MAKEFLAGS) -C OMCompiler omc-no-sim
	mv build cross-build
	$(MAKE) clean
endif
	# Cross-compile done, now configure for real
	# wily armhf requires -lm for blas...
	./configure CFLAGS="$(CFLAGS)" CC="$(CC)" CXX="$(CXX)" LDFLAGS="$(LDFLAGS)" OMPCC="gcc -fopenmp" \
	--host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--with-lapack="-llapack -lblas -lm" \
	--with-omniORB \
	--without-paradiseo \
	--without-omlibrary \
	--disable-modelica3d \
	$(CONF_OPTS) $(CONF_OPTS_CROSS)
	# Add here commands to configure the package.
#       --with-static-sqlite=`test -f /usr/lib/*/libsqlite3.a && echo /usr/lib/*/libsqlite3.a || echo /usr/lib/libsqlite3.a` \
#	--with-static-lpsolve=/usr
#	--with-static-readline=/usr

	# Add here commands to compile the package.
	$(MAKE) $(MAKEFLAGS)
	# Skip the testsuite log. People can look it up on hudson
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	# Add here commands to clean up after the build process.
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -popenmodelica -Pdebian/tmp
	# Add here commands to install the package into debian/tmp.
	$(MAKE) $(MAKEFLAGS) install $(EXTRA_INSTALL) DESTDIR=$(DEST)
	# We add our own Debian-specific copyright file
	rm -f $(DEST)/usr/share/doc/omc/COPYING
	dh_install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --list-missing
	dh_installmenu
	dh_installmime
	dh_link
	dh_strip
	# dh_compress -X.pdf -X.onb -X.c -X.h -X.mo -X.mos -Xomc_helptext.txt -X.py
	dh_fixperms
	dh_installdeb
	dh_makeshlibs -V
	dh_shlibdeps -l/usr/lib/$(DEB_HOST_GNU_TYPE)/omc -Lomc -- --ignore-missing-info
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## openmodelica 1.12.0~dev.beta1

=== OMCompiler/3rdParty/libzmq/CMakeLists.txt ===
# CMake build script for ZeroMQ

cmake_minimum_required (VERSION 2.8.12)
project (ZeroMQ)

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}")

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
endif()
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_C11)
if(COMPILER_SUPPORTS_C11)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
endif()

# Will be used to add flags to pkg-config useful when apps want to statically link
set (pkg_config_libs_private "")

option (WITH_OPENPGM "Build with support for OpenPGM" OFF)
option (WITH_VMCI "Build with support for VMware VMCI socket" OFF)

if (APPLE)
    option (ZMQ_BUILD_FRAMEWORK "Build as OS X framework" OFF)
endif ()

# Select curve encryption library, defaults to tweetnacl
# To use libsodium instead, use --with-libsodium (must be installed)
# To disable curve, use --disable-curve

option (WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" OFF)
option (ENABLE_CURVE "Enable CURVE security" ON)

if (NOT ENABLE_CURVE)
    message (STATUS "CURVE security is disabled")

elseif (WITH_LIBSODIUM)
    find_package (Sodium)
    if (SODIUM_FOUND)
        message (STATUS "Using libsodium for CURVE security")
        include_directories (${SODIUM_INCLUDE_DIRS})

        # On Solaris, libsodium depends on libssp
        if (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
            target_link_libraries (libzmq ssp)
        endif ()
        set (ZMQ_USE_LIBSODIUM 1)
        set (ZMQ_HAVE_CURVE 1)
        set (pkg_config_libs_private "${pkg_config_libs_private} -lsodium")
    else ()
        message (FATAL_ERROR
            "libsodium is not installed. Install it, then run CMake again")
    endif ()

else ()
    message (STATUS "Using tweetnacl for CURVE security")
    list (APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
    set (ZMQ_USE_TWEETNACL 1)
    set (ZMQ_HAVE_CURVE 1)
endif ()

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

if (EXISTS "${SOURCE_DIR}/.git")
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else ()
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif ()
IF (ENABLE_DRAFTS)
    ADD_DEFINITIONS (-DZMQ_BUILD_DRAFT_API)
    set (pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
ELSE (ENABLE_DRAFTS)
    set (pkg_config_defines "")
ENDIF (ENABLE_DRAFTS)

option (WITH_MILITANT "Enable militant assertions" OFF)
if (WITH_MILITANT)
    add_definitions(-DZMQ_ACT_MILITANT)
endif()

set (POLLER "" CACHE STRING "Choose polling system. valid values are
                            kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")

include (CheckFunctionExists)
include (CheckTypeSize)

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/event.h)
    check_function_exists (kqueue HAVE_KQUEUE)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_KQUEUE)
        set (POLLER "kqueue")
    endif()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/epoll.h)
    check_function_exists (epoll_create HAVE_EPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_EPOLL)
        set (POLLER "epoll")
        check_function_exists (epoll_create1 HAVE_EPOLL_CLOEXEC)
        if (HAVE_EPOLL_CLOEXEC)
            set (ZMQ_USE_EPOLL_CLOEXEC 1)
        endif ()
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/devpoll.h)
    check_type_size ("struct pollfd" DEVPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_DEVPOLL)
        set (POLLER "devpoll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/pollset.h)
    check_function_exists (pollset_create HAVE_POLLSET)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_POLLSET)
        set (POLLER "pollset")
    endif()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES poll.h)
    check_function_exists (poll HAVE_POLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_POLL)
        set (POLLER "poll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    if (WIN32)
        set (CMAKE_REQUIRED_INCLUDES winsock2.h)
        set (HAVE_SELECT 1)
    else ()
        set (CMAKE_REQUIRED_INCLUDES sys/select.h)
        check_function_exists (select HAVE_SELECT)
        set (CMAKE_REQUIRED_INCLUDES)
    endif ()
    if (HAVE_SELECT)
        set (POLLER "select")
    else ()
        message (FATAL_ERROR
            "Could not autodetect polling method")
    endif ()
endif ()

if (POLLER STREQUAL "kqueue"
 OR POLLER STREQUAL "epoll"
 OR POLLER STREQUAL "devpoll"
 OR POLLER STREQUAL "pollset"
 OR POLLER STREQUAL "poll"
 OR POLLER STREQUAL "select")
    message (STATUS "Detected ${POLLER} polling method")
    string (TOUPPER ${POLLER} UPPER_POLLER)
    set (ZMQ_USE_${UPPER_POLLER} 1)
else ()
    message (FATAL_ERROR "Invalid polling method")
endif ()

set (ZMQ_CMAKE_MODULES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/builds/cmake/Modules)
list (APPEND CMAKE_MODULE_PATH ${ZMQ_CMAKE_MODULES_DIR})

include (TestZMQVersion)
if (NOT CMAKE_CROSSCOMPILING)
  include (ZMQSourceRunChecks)
endif ()
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckCCompilerFlag)
include (CheckCXXCompilerFlag)
include (CheckCSourceCompiles)
include (CheckCSourceRuns)
include (CMakeDependentOption)
include (CheckCXXSymbolExists)

check_include_files (ifaddrs.h ZMQ_HAVE_IFADDRS)
check_include_files (windows.h ZMQ_HAVE_WINDOWS)
if( ${CMAKE_SYSTEM_NAME} STREQUAL "WindowsStore" AND ${CMAKE_SYSTEM_VERSION} STREQUAL "10.0")
  SET(ZMQ_HAVE_WINDOWS_UWP ON)
  ADD_DEFINITIONS(-D_WIN32_WINNT=_WIN32_WINNT_WIN10)
endif()
check_include_files (sys/uio.h ZMQ_HAVE_UIO)
check_include_files (sys/eventfd.h ZMQ_HAVE_EVENTFD)
if (ZMQ_HAVE_EVENTFD AND NOT CMAKE_CROSSCOMPILING)
  zmq_check_efd_cloexec ()
endif ()

check_library_exists (ws2_32 fopen "" HAVE_WS2_32) # TODO: Why doesn't something logical like WSAStartup work?
check_library_exists (ws2 fopen "" HAVE_WS2)
check_library_exists (rpcrt4 fopen "" HAVE_RPCRT4) # UuidCreateSequential
check_library_exists (iphlpapi fopen "" HAVE_IPHLAPI) # GetAdaptersAddresses

check_cxx_symbol_exists (SO_PEERCRED sys/socket.h ZMQ_HAVE_SO_PEERCRED)
check_cxx_symbol_exists (LOCAL_PEERCRED sys/socket.h ZMQ_HAVE_LOCAL_PEERCRED)

find_library (RT_LIBRARY rt)

find_package (Threads)


if (WIN32 AND NOT CYGWIN)
  if (NOT HAVE_WS2_32 AND NOT HAVE_WS2)
    message (FATAL_ERROR "Cannot link to ws2_32 or ws2")
  endif ()

  if (NOT HAVE_RPCRT4)
    message (FATAL_ERROR "Cannot link to rpcrt4")
  endif ()

  if (NOT HAVE_IPHLAPI)
    message (FATAL_ERROR "Cannot link to iphlapi")
  endif ()
endif ()

set (CMAKE_REQUIRED_LIBRARIES rt)
check_function_exists (clock_gettime HAVE_CLOCK_GETTIME)
set (CMAKE_REQUIRED_LIBRARIES)

set (CMAKE_REQUIRED_INCLUDES unistd.h)
check_function_exists (fork HAVE_FORK)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES sys/time.h)
check_function_exists (gethrtime HAVE_GETHRTIME)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES stdlib.h)
check_function_exists (mkdtemp HAVE_MKDTEMP)
set (CMAKE_REQUIRED_INCLUDES)

add_definitions (-D_REENTRANT -D_THREAD_SAFE)
add_definitions (-DZMQ_CUSTOM_PLATFORM_HPP)

option (ENABLE_EVENTFD "Enable/disable eventfd" ZMQ_HAVE_EVENTFD)

macro (zmq_check_cxx_flag_prepend flag)
  check_cxx_compiler_flag ("${flag}" HAVE_FLAG_${flag})

  if (HAVE_FLAG_${flag})
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
  endif ()
endmacro ()


if (MSVC)
  zmq_check_cxx_flag_prepend ("/W3")

  if (MSVC_IDE)
    set (MSVC_TOOLSET "-${CMAKE_VS_PLATFORM_TOOLSET}")
  else ()
    set (MSVC_TOOLSET "")
  endif ()
else ()
  zmq_check_cxx_flag_prepend ("-Wall")
endif ()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  zmq_check_cxx_flag_prepend ("-Wextra")
endif ()

#   TODO: why is -Wno-long-long defined differently than in configure.ac?
zmq_check_cxx_flag_prepend ("-Wno-long-long")
zmq_check_cxx_flag_prepend ("-Wno-uninitialized")

option (LIBZMQ_PEDANTIC "" ON)
option (LIBZMQ_WERROR "" OFF)

if (LIBZMQ_PEDANTIC)
  zmq_check_cxx_flag_prepend ("-pedantic")

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Intel")
    zmq_check_cxx_flag_prepend ("-strict-ansi")
  endif ()

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
    zmq_check_cxx_flag_prepend ("-compat=5")
  endif ()
endif ()

if (LIBZMQ_WERROR)
  zmq_check_cxx_flag_prepend ("-Werror")
  zmq_check_cxx_flag_prepend ("-errwarn=%all")
endif ()

if (CMAKE_SYSTEM_PROCESSOR MATCHES "^sparc")
  zmq_check_cxx_flag_prepend ("-mcpu=v9")
endif ()

if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
  zmq_check_cxx_flag_prepend ("-features=zla")
endif ()


if (CMAKE_SYSTEM_NAME MATCHES "SunOS" OR CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  message (STATUS "Checking whether atomic operations can be used")
  check_c_source_compiles (
  "
   #include <atomic.h>

    int main ()
    {
      uint32_t value;
      atomic_cas_32 (&value, 0, 0);
      return 0;
    }
    "
    HAVE_ATOMIC_H)

  if (NOT HAVE_ATOMIC_H)
    set (ZMQ_FORCE_MUTEXES 1)
  endif ()
endif ()


#-----------------------------------------------------------------------------
if (NOT CMAKE_CROSSCOMPILING)
  zmq_check_sock_cloexec ()
  zmq_check_so_keepalive ()
  zmq_check_tcp_keepcnt ()
  zmq_check_tcp_keepidle ()
  zmq_check_tcp_keepintvl ()
  zmq_check_tcp_keepalive ()
  zmq_check_tcp_tipc ()
  zmq_check_pthread_setname ()
endif ()

if (    CMAKE_SYSTEM_NAME MATCHES "Linux"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/kFreeBSD"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/Hurd"
    OR CYGWIN)
  add_definitions (-D_GNU_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  add_definitions (-D__BSD_VISIBLE)
elseif (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  add_definitions (-D_NETBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  add_definitions (-D_OPENBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "SunOS")
  add_definitions (-D_PTHREADS)
elseif (CMAKE_SYSTEM_NAME MATCHES "HP-UX")
  add_definitions (-D_POSIX_C_SOURCE=200112L)
  zmq_check_cxx_flag_prepend (-Ae)
elseif (CMAKE_SYSTEM_NAME MATCHES "Darwin")
  add_definitions (-D_DARWIN_C_SOURCE)
endif ()

set (CMAKE_PYTHON_VERSION 2.7 2.6 2.5 2.4)
find_package (PythonInterp)
find_package (AsciiDoc)

cmake_dependent_option (WITH_DOC "Build Reference Guide documentation (requires DocBook)" ON
                       "PYTHONINTERP_FOUND;ASCIIDOC_FOUND" OFF)

if (MSVC)
  if (WITH_OPENPGM)
    #   set (OPENPGM_ROOT "" CACHE PATH "Location of OpenPGM")
    set (OPENPGM_VERSION_MAJOR 5)
    set (OPENPGM_VERSION_MINOR 2)
    set (OPENPGM_VERSION_MICRO 122)
    if (CMAKE_CL_64)
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x64 detected - ${OPENPGM_ROOT}")
    else ()
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Wow6432Node\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x86 detected - ${OPENPGM_ROOT}")
    endif (CMAKE_CL_64)
    set (OPENPGM_INCLUDE_DIRS ${OPENPGM_ROOT}/include)
    set (OPENPGM_LIBRARY_DIRS ${OPENPGM_ROOT}/lib)
    set (OPENPGM_LIBRARIES
      optimized libpgm${MSVC_TOOLSET}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib
      debug libpgm${MSVC_TOOLSET}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib)
  endif ()
else ()
  if (WITH_OPENPGM)
    #  message (FATAL_ERROR "WITH_OPENPGM not implemented")

=== OMCompiler/3rdParty/metis-5.1.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(METIS)

add_definitions(${MSYS_INCLUDE_LOC})
set(GKLIB_PATH "GKlib" CACHE PATH "path to GKlib")
set(SHARED FALSE CACHE BOOL "build a shared library")

if(MSVC)
  set(METIS_INSTALL FALSE)
else()
  set(METIS_INSTALL TRUE)
endif()

# Configure libmetis library.
if(SHARED)
  set(METIS_LIBRARY_TYPE SHARED)
else()
  set(METIS_LIBRARY_TYPE STATIC)
endif(SHARED)

include(${GKLIB_PATH}/GKlibSystem.cmake)
# Add include directories.
include_directories(${GKLIB_PATH})
include_directories(include)
# Recursively look for CMakeLists.txt in subdirs.
add_subdirectory("include")
add_subdirectory("libmetis")
add_subdirectory("programs")

=== OMCompiler/3rdParty/SuiteSparse/AMD/Makefile ===
#------------------------------------------------------------------------------
# AMD Makefile (for GNU Make or original make)
#------------------------------------------------------------------------------

default: library

include ../UFconfig/UFconfig.mk

# compile just the C-callable libraries (not mexFunctions or Demos)
library:
	( cd Lib    ; $(MAKE) )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Doc    ; $(MAKE) purge )

distclean: purge

# create PDF documents for the original distribution
doc:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Doc    ; $(MAKE) )

ccode: library

lib: library

## openmodelica 1.12.0~dev.beta2

=== OMCompiler/Compiler/Translation/Makefile ===
localedir = $(OMBUILDDIR)/share/locale/
locales = de sv es

ALL_DIRS=../FrontEnd ../BackEnd ../Main ../Script ../Util ../Global ../SimCode
TEMPLATE_DIR=../Template

release:
	for locale in $(locales); do mkdir -p $(localedir)/$$locale/LC_MESSAGES && msgfmt -o$(localedir)/$$locale/LC_MESSAGES/openmodelica.mo $$locale.po; done
update:
	xgettext --msgid-bugs-address="openmodelica at ida.liu.se" --copyright-holder="Open Source Modelica Consortium (OSMC)" --package-name=OpenModelica --package-version=trunk -oopenmodelica.pot -LC++ --from-code=UTF-8 $(ALL_DIRS:%=%/*.mo) $(TEMPLATE_DIR:%=%/*.tpl) ../runtime/*.c ../runtime/*.cpp
	sed -i s/CHARSET/UTF-8/ openmodelica.pot

merge-all: update
	for f in $(locales); do msgmerge -U $$f.po openmodelica.pot; done

=== OMEdit/qjson/tests/scanner/CMakeLists.txt ===
##### Probably don't want to edit below this line #####

SET( QT_USE_QTTEST TRUE )

IF (NOT Qt5Core_FOUND)
  # Use it
  INCLUDE( ${QT_USE_FILE} )
ENDIF()

INCLUDE(AddFileDependencies)

# Include the library include directories, and the current build directory (moc)
INCLUDE_DIRECTORIES(
  ../../src
  ../../include
  ${CMAKE_CURRENT_BINARY_DIR}
)

SET( UNIT_TESTS
  testscanner
)

# Build the tests
FOREACH(test ${UNIT_TESTS})
  MESSAGE(STATUS "Building ${test}")
  IF (NOT Qt5Core_FOUND)
    QT4_WRAP_CPP(MOC_SOURCE ${test}.cpp)
  ENDIF()
  ADD_EXECUTABLE(
    ${test}
    ${test}.cpp
  )

  if(WIN32 AND BUILD_SHARED_LIBS)
    set(QJSON_SCANNER qjson_scanner)
  endif()

  ADD_FILE_DEPENDENCIES(${test}.cpp ${MOC_SOURCE})
  TARGET_LINK_LIBRARIES(
    ${test}
    ${QT_LIBRARIES}
    ${TEST_LIBRARIES}
    qjson
    ${QJSON_SCANNER}
  )
  if (QJSON_TEST_OUTPUT STREQUAL "xml")
    # produce XML output
    add_test( ${test} ${test} -xml -o ${test}.tml )
  else (QJSON_TEST_OUTPUT STREQUAL "xml")
    add_test( ${test} ${test} )
  endif (QJSON_TEST_OUTPUT STREQUAL "xml")
ENDFOREACH()

=== OMCompiler/3rdParty/sundials/src/idas/CMakeLists.txt ===
# ---------------------------------------------------------------
# $Revision: 4135 $
# $Date: 2014-06-13 15:55:05 -0700 (Fri, 13 Jun 2014) $
# ---------------------------------------------------------------
# Programmer:  Radu Serban @ LLNL
# ---------------------------------------------------------------
# LLNS Copyright Start
# Copyright (c) 2014, Lawrence Livermore National Security
# This work was performed under the auspices of the U.S. Department 
# of Energy by Lawrence Livermore National Laboratory in part under 
# Contract W-7405-Eng-48 and in part under Contract DE-AC52-07NA27344.
# Produced at the Lawrence Livermore National Laboratory.
# All rights reserved.
# For details, see the LICENSE file.
# LLNS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the IDAS library

INSTALL(CODE "MESSAGE(\"\nInstall IDAS\n\")")

# Add variable idas_SOURCES with the sources for the IDAS library
SET(idas_SOURCES
  idas.c
  idaa.c
  idas_io.c
  idas_ic.c
  idaa_io.c
  idas_direct.c
  idas_band.c
  idas_dense.c
  idas_sparse.c
  idas_spils.c
  idas_spbcgs.c
  idas_spgmr.c
  idas_sptfqmr.c
  idas_bbdpre.c
  )

IF(KLU_FOUND)
    LIST(APPEND idas_SOURCES idas_klu.c)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND idas_SOURCES idas_superlumt.c)
ENDIF()

# Add variable shared_SOURCES with the common SUNDIALS sources which will
# also be included in the IDAS library
SET(shared_SOURCES
  sundials_nvector.c
  sundials_math.c
  sundials_direct.c
  sundials_band.c
  sundials_dense.c
  sundials_iterative.c
  sundials_sparse.c
  sundials_spbcgs.c
  sundials_spgmr.c
  sundials_sptfqmr.c
  )

# Add prefix with complete path to the common SUNDIALS sources
ADD_PREFIX(${sundials_SOURCE_DIR}/src/sundials/ shared_SOURCES)

# Add variable idas_HEADERS with the exported IDAS header files
SET(idas_HEADERS
  idas_band.h
  idas_bbdpre.h
  idas_dense.h
  idas_direct.h
  idas.h
  idas_sparse.h
  idas_spbcgs.h
  idas_spgmr.h
  idas_spils.h
  idas_sptfqmr.h
  )

IF(KLU_FOUND)
    LIST(APPEND idas_HEADERS idas_klu.h)
ENDIF()

IF(SUPERLUMT_FOUND)
    LIST(APPEND idas_HEADERS idas_superlumt.h)
ENDIF()

# Add prefix with complete path to the IDAS header files
ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_HEADERS)

# If Blas/Lapack support was enabled, set-up additional file lists
IF(LAPACK_FOUND)
  SET(idas_BL_SOURCES idas_lapack.c)
  SET(idas_BL_HEADERS idas_lapack.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_BL_HEADERS)
ELSE(LAPACK_FOUND)
  SET(idas_BL_SOURCES "")
  SET(idas_BL_HEADERS "")
ENDIF(LAPACK_FOUND)

IF(SUPERLUMT_FOUND)
  SET(idas_SLU_SOURCES idas_superlumt.c)
  SET(idas_SLU_HEADERS idas_superlumt.h)
  ADD_PREFIX(${sundials_SOURCE_DIR}/include/idas/ idas_SLU_HEADERS)
ELSE(SUPERLUMT_FOUND)
  SET(idas_SLU_SOURCES "")
  SET(idas_SLU_HEADERS "")
ENDIF(SUPERLUMT_FOUND)

# Add source directories to include directories for access to
# implementation only header files.
INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(../sundials)

# Define C preprocessor flag -DBUILD_SUNDIALS_LIBRARY 
ADD_DEFINITIONS(-DBUILD_SUNDIALS_LIBRARY)

# Build the static library
IF(BUILD_STATIC_LIBS)

  # Add the build target for the static IDAS library
  ADD_LIBRARY(sundials_idas_static STATIC 
    ${idas_SOURCES} ${idas_BL_SOURCES} ${idas_SLU_SOURCES}  ${shared_SOURCES})

  TARGET_LINK_LIBRARIES(sundials_idas_static ${KLU_LIBRARIES} ${LAPACK_LIBRARIES})
	
  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_idas_static
    PROPERTIES OUTPUT_NAME sundials_idas CLEAN_DIRECT_OUTPUT 1)

  # Install the IDA library
  INSTALL(TARGETS sundials_idas_static DESTINATION lib)

ENDIF(BUILD_STATIC_LIBS)

# Build the shared library
IF(BUILD_SHARED_LIBS)

  # Add the build target for the IDAS library
  ADD_LIBRARY(sundials_idas_shared SHARED 
    ${idas_SOURCES}  ${idas_BL_SOURCES} ${idas_SLU_SOURCES} ${shared_SOURCES})
  
  TARGET_LINK_LIBRARIES(sundials_idas_shared ${KLU_LIBRARIES} ${LAPACK_LIBRARIES})
  
  # Set the library name and make sure it is not deleted
  SET_TARGET_PROPERTIES(sundials_idas_shared
    PROPERTIES OUTPUT_NAME sundials_idas CLEAN_DIRECT_OUTPUT 1)

  # Set VERSION and SOVERSION for shared libraries
  SET_TARGET_PROPERTIES(sundials_idas_shared
    PROPERTIES VERSION ${idaslib_VERSION} SOVERSION ${idaslib_SOVERSION})

  # Install the IDAS library
  INSTALL(TARGETS sundials_idas_shared DESTINATION lib)

ENDIF(BUILD_SHARED_LIBS)

# Install the IDAS header files
INSTALL(FILES ${idas_HEADERS} ${idas_BL_HEADERS} ${idas_SLU_HEADERS} DESTINATION include/idas)

# Install the IDAS implementation header file
INSTALL(FILES idas_impl.h DESTINATION include/idas)

#
MESSAGE(STATUS "Added IDAS module")

=== OMCompiler/SimulationRuntime/cpp/Core/DataExchange/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${DataExchangeName})

add_library(${DataExchangeName} SimData.cpp FactoryExport.cpp XmlPropertyReader.cpp)

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${DataExchangeName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING")
endif(NOT BUILD_SHARED_LIBS)

if(NOT BOOST_STATIC_LINKING)
  target_link_libraries (${DataExchangeName} ${Boost_LIBRARIES} ${ExtensionUtilitiesName}  ${ModelicaName})
endif(NOT BOOST_STATIC_LINKING)

add_precompiled_header(${DataExchangeName} Include/Core/Modelica.h)

install(TARGETS ${DataExchangeName} DESTINATION ${LIBINSTALLEXT})
install(FILES
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/IHistory.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/ISimVar.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/SimData.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/Writer.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/SimDouble.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/SimBoolean.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/XmlPropertyReader.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/IPropertyReader.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/FactoryExport.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/FactoryPolicy.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/DefaultContainerManager.h
  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/ParallelContainerManager.h
  DESTINATION include/omc/cpp/Core/DataExchange)

=== OMCompiler/SimulationRuntime/cpp/Core/System/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${SystemName})
set(BASE_LIB "" CACHE INTERNAL "" )

#IF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
#add_library(${BasiLibName} STATIC tpl.cpp )
#set_target_properties(${BasiLibName} PROPERTIES COMPILE_FLAGS -fPIC)
#set(BASE_LIB -l${BasiLibName} CACHE INTERNAL "" )
#ENDIF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))

# add the system default implementation library
add_library(${SystemName} LinearAlgLoopDefaultImplementation.cpp NonLinearAlgLoopDefaultImplementation.cpp AlgLoopSolverFactory.cpp EventHandling.cpp DiscreteEvents.cpp ContinuousEvents.cpp SystemDefaultImplementation.cpp SimVars.cpp FactoryExport.cpp)

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${SystemName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING;ENABLE_SUNDIALS_STATIC")
endif(NOT BUILD_SHARED_LIBS)

target_link_libraries(${SystemName} ${Boost_LIBRARIES} ${LAPACK_LIBRARIES} ${OMCFactoryName} ${SimulationSettings} ${ExtensionUtilitiesName})
add_precompiled_header(${SystemName} Include/Core/Modelica.h)

install(TARGETS ${SystemName} DESTINATION ${LIBINSTALLEXT})

#IF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
#install (TARGETS ${BasiLibName} DESTINATION ${LIBINSTALLEXT})
#ENDIF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
install(FILES
  ${CMAKE_SOURCE_DIR}/Include/Core/System/SystemDefaultImplementation.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/LinearAlgLoopDefaultImplementation.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/NonLinearAlgLoopDefaultImplementation.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/EventHandling.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/DiscreteEvents.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ContinuousEvents.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/SimVars.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/FactoryExport.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ILinearAlgLoop.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/INonLinearAlgLoop.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IAlgLoopSolverFactory.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/AlgLoopSolverFactory.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IContinuous.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IMixedSystem.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IEvent.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ITime.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ISystemProperties.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ISystemInitialization.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IStepEvent.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IWriteOutput.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ISystemTypes.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/IStateSelection.h
  ${CMAKE_SOURCE_DIR}/Include/Core/System/ISimVars.h
  DESTINATION include/omc/cpp/Core/System)

=== OMCompiler/SimulationRuntime/cpp/Solver/Broyden/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${BroydenName})

add_library(${BroydenName} Broyden.cpp BroydenSettings.cpp FactoryExport.cpp )

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${BroydenName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING")
endif(NOT BUILD_SHARED_LIBS)

target_link_libraries(${BroydenName} ${ExtensionUtilitiesName} ${Boost_LIBRARIES} ${LAPACK_LIBRARIES}  ${ModelicaName})
add_precompiled_header(${BroydenName} Include/Core/Modelica.h)

install(TARGETS ${BroydenName} DESTINATION ${LIBINSTALLEXT})
install(FILES
  ${CMAKE_SOURCE_DIR}/Include/Solver/Broyden/Broyden.h
  ${CMAKE_SOURCE_DIR}/Include/Solver/Broyden/BroydenSettings.h
  ${CMAKE_SOURCE_DIR}/Include/Solver/Broyden/FactoryExport.h
  DESTINATION include/omc/cpp/Solver/Broyden)

=== OMCompiler/SimulationRuntime/cpp/Solver/Kinsol/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${KinsolName})

add_library(${KinsolName} Kinsol.cpp KinsolLapack.cpp KinsolSettings.cpp FactoryExport.cpp)

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${KinsolName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING;ENABLE_SUNDIALS_STATIC")
endif(NOT BUILD_SHARED_LIBS)

add_precompiled_header(${KinsolName} Include/Core/Modelica.h)
target_link_libraries(${KinsolName} ${ExtensionUtilitiesName} ${Boost_LIBRARIES} ${SUNDIALS_LIBRARIES} ${LAPACK_LIBRARIES}  ${ModelicaName} )   

install(TARGETS ${KinsolName} DESTINATION ${LIBINSTALLEXT})
install(FILES
  ${CMAKE_SOURCE_DIR}/Include/Solver/Kinsol/Kinsol.h
  ${CMAKE_SOURCE_DIR}/Include/Solver/Kinsol/KinsolSettings.h
  ${CMAKE_SOURCE_DIR}/Include/Solver/Kinsol/FactoryExport.h
  DESTINATION include/omc/cpp/Solver/Kinsol)

=== OMCompiler/SimulationRuntime/cpp/Solver/LinearSolver/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${LinearSolverName})

add_library(${LinearSolverName} LinearSolver.cpp LinearSolverSettings.cpp FactoryExport.cpp)

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${LinearSolverName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING;ENABLE_SUNDIALS_STATIC")
endif(NOT BUILD_SHARED_LIBS)

add_precompiled_header(${LinearSolverName} Include/Core/Modelica.h)
target_link_libraries(${LinearSolverName}   ${KLU_LIBRARIES} ${ExtensionUtilitiesName} ${Boost_LIBRARIES} ${SUNDIALS_LIBRARIES} ${LAPACK_LIBRARIES}  ${ModelicaName})  

install(TARGETS ${LinearSolverName} DESTINATION ${LIBINSTALLEXT})
install(FILES
  ${CMAKE_SOURCE_DIR}/Include/Solver/LinearSolver/LinearSolver.h
  ${CMAKE_SOURCE_DIR}/Include/Solver/LinearSolver/FactoryExport.h
  DESTINATION include/omc/cpp/Solver/LinearSolver)

=== OMCompiler/SimulationRuntime/cpp/Solver/RTEuler/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

project(${RTEulerName})

add_library(${RTEulerName} RTEuler.cpp RTEulerSettings.cpp FactoryExport.cpp )

if(NOT BUILD_SHARED_LIBS)
  set_target_properties(${RTEulerName} PROPERTIES COMPILE_DEFINITIONS "RUNTIME_STATIC_LINKING")
endif(NOT BUILD_SHARED_LIBS)

target_link_libraries (${RTEulerName} ${SolverName} ${Boost_LIBRARIES} ${LAPACK_LIBRARIES})

install(TARGETS ${RTEulerName} DESTINATION ${LIBINSTALLEXT})
